
!Time class methodsFor: '*sixx-instance creation' stamp: 'mu 1/16/2007 11:28'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^self readSixxContentStringFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Time class methodsFor: '*sixx-private' stamp: 'mu 1/16/2007 11:28'!
readSixxContentStringFrom: aStream
	"Squeak specific"
	^ self readFrom: aStream! !

!Time methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 22:29'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!Time methodsFor: '*sixx-private' stamp: 'MU 9/16/2002 22:28'!
sixxContentString
	"Squeak Specific"
	^self printString! !

!ShortIntegerArray class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 21:07'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^self withAll: col! !

!ShortIntegerArray methodsFor: '*sixx-printing' stamp: 'mu 6/25/2004 21:03'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

!Rectangle class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 19:38'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| readStr origin corner |

	"For old format"
	(SixxXmlUtil elementsFrom: sixxElement ) isEmpty ifFalse: [
		^super createInstanceOf: aClass withSixxElement: sixxElement
	].

	readStr := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	origin := ((readStr upTo: $@) asNumber) @ (readStr upTo: Character space) asNumber.
	readStr upToAll: 'corner: '.
	corner := ((readStr upTo: $@) asNumber) @ (readStr upToEnd) asNumber.
	^origin corner: corner
! !

!Rectangle methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 19:31'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self printString.
	! !

!Preferences class methodsFor: '*sixx-personalization' stamp: 'mu 6/25/2004 19:41'!
sixxLoadPreferencesFrom: aFileName
	| stream params dict desktopColor |
	stream _ SixxReadStream readOnlyFileNamed: aFileName.
	params _ stream next.
	self assert: (params isKindOf: IdentityDictionary).
	params removeKey: #PersonalDictionaryOfPreferences.
	dict _ stream next.
	self assert: (dict isKindOf: IdentityDictionary).
	desktopColor _ stream next.
	stream close.
	dict keysAndValuesDo:
		[:key :value | (self preferenceAt: key ifAbsent: [nil]) ifNotNilDo:
			[:pref | pref preferenceValue: value preferenceValue]].

	params keysAndValuesDo: [ :key :value | self setParameter: key to: value ].

	Smalltalk isMorphic
		ifTrue: [ World fillStyle: desktopColor ]
		ifFalse: [ self desktopColor: desktopColor. ScheduledControllers updateGray ].
! !

!Preferences class methodsFor: '*sixx-personalization' stamp: 'mu 6/25/2004 19:27'!
sixxStorePreferencesIn: aFileName
	| stream |
	#(Prevailing PersonalPreferences) do: [ :ea | Parameters removeKey: ea ifAbsent: []].  
	stream _ SixxWriteStream newFileNamed: aFileName.
	stream nextPut: Parameters.
	stream nextPut: DictionaryOfPreferences.
	Smalltalk isMorphic
		ifTrue: [ stream nextPut: World fillStyle ]
		ifFalse: [ stream nextPut: DesktopColor ].
	stream close.! !

!Point class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 20:31'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| readStr x y |
	readStr := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	x _ (readStr upTo: $@) asNumber.
	y _ (readStr upToEnd) asNumber.
	^self x: x y: y! !

!Point methodsFor: '*sixx-printing' stamp: 'mu 6/25/2004 20:23'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: x printString.
	aStream nextPut: $@.
	aStream nextPutAll: y printString.
	
	! !

!SixxMockObjectInitializingOnRead methodsFor: '*sixx-initializing' stamp: 'mu 12/17/2006 22:37'!
sixxInitialize
	cache1 := 1234567.
	cache2 := 'this is cache2'! !

!FloatArray class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:19'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^ col asFloatArray! !

!FloatArray methodsFor: '*sixx-printing' stamp: 'MU 6/29/2002 16:03'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

!Symbol class methodsFor: '*sixx-instance creation' stamp: 'mu 5/9/2002 17:46'!
createInstanceOf: aClass withSixxElement: sixxElement
	^(super createInstanceOf: aClass withSixxElement: sixxElement) asSymbol! !

!Symbol methodsFor: '*sixx-private' stamp: 'mu 2/7/2006 21:12'!
sixxType
	^#Symbol! !

!Number class methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/15/2002 18:06'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ (SixxXmlUtil characterDataFrom: sixxElement) asNumber
	! !

!Number methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:36'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self asString
	! !

!UndefinedObject class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:20'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!UndefinedObject methodsFor: '*sixx-private' stamp: 'MU 9/16/2002 18:55'!
asSixxKey
	"For some Smalltalks which do not support nil element in IdentityDictionary"
	^#'SIXX-UndefinedObject(98ea8c30-2bf8-4d23-9da2-ad1ee0e29eff)'
! !

!UndefinedObject methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:36'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !

!UndefinedObject methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 18:56'!
sixxOn: aStream name: nameString indent: level context: dictionary 
	| key |
	key := self asSixxKey.
	aStream tab: level.
	(dictionary includesKey: key )
		ifTrue: [aStream
				nextPutAll: (self
						sixxRefTagStartString: (dictionary at: key) name: nameString)]
		ifFalse: [| idStr | 
			idStr := dictionary size asString.			
			dictionary at: key put: idStr.
			aStream
				nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !

!Dictionary methodsFor: '*sixx-printing-six' stamp: 'mu 5/10/2002 14:33'!
sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self
		associationsDo: [:each | each
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level.! !

!FixedFaceFont methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 23:33'!
emphasis
	^0! !

!Interval class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:22'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Interval methodsFor: '*sixx-printing' stamp: 'minami 3/18/2003 01:47'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self printString! !

!ClassDescription methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:32'!
sixxContentOn: aStream indent: level context: dictionary
	| instVars startIndex  |	
	aStream cr.
	instVars := self class allInstVarNames.
	startIndex := Object class allInstVarNames size + 1.
	startIndex to: instVars size do: [:idx | 
			(self instVarAt: idx)
				sixxOn: aStream
				name: (instVars at: idx)
				indent: level + 1
				context: dictionary].! !

!WordArray class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:21'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^ col asWordArray! !

!WordArray methodsFor: '*sixx-printing' stamp: 'MU 6/29/2002 16:00'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

!Collection class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 03:32'!
createInstanceOf: aClass withSixxElement: sixxElement 
	"override to use #createMixedFieldsInstanceOf:withSixxElement: if you have extra inst vars"
	^ self
		sixxNew: aClass
		size: (SixxXmlUtil elementsFrom: sixxElement) size
		withSixxElement: sixxElement! !

!Collection methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 03:59'!
initializeFromSixxElement: sixxElement context: aDictionary 
	"override to use #initializeMixedFieldsFromSixxElement:context: if having some inst vars"
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | 
			| childInst | 
			childInst := self class fromSixxElement: elem context: aDictionary.
			self add: childInst]! !

!Collection methodsFor: '*sixx-printing' stamp: 'mu 6/25/2004 00:37'!
sixxContentOn: aStream indent: level context: dictionary
	"default just uses #do: - override it to use #sixxAllFieldsOn:indent:context: if your collection need to store some inst vars"
	aStream cr.
	self
		do: [:each | each
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level.! !

!Collection methodsFor: '*sixx-private' stamp: 'mu 6/25/2004 04:55'!
sixxIndexFieldsOn: aStream indent: level context: dictionary
	self size = 0 ifTrue: [^self].
	aStream cr.
	self do: 
			[:each | 
			each 
				sixxOn: aStream
				indent: level
				context: dictionary]

! !

!Collection methodsFor: '*sixx-private' stamp: 'mu 6/25/2004 04:55'!
sixxMixedFieldsOn: aStream indent: level context: dictionary
	"override"
	"Usually Collection's inst vars are not needed for serialization"
	self sixxIndexFieldsOn: aStream indent: level context: dictionary.! !

!Metaclass methodsFor: '*sixx-instance creation' stamp: 'MU 9/2/2002 02:46'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ aClass isMeta
		ifTrue: [aClass soleInstance]
		ifFalse: [aClass]! !

!AbstractFont class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 23:35'!
createInstanceOf: aClass withSixxElement: sixxElement 

	"For old format"
	| stream space familyName size emphasisCode |
	(SixxXmlUtil elementsFrom: sixxElement ) isEmpty ifFalse: [
		^super createInstanceOf: aClass withSixxElement: sixxElement
	].

	stream := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	space := Character space.
	familyName := stream upTo: space.
	size := (stream upTo: space) asInteger.
	emphasisCode := (stream upTo: space) asInteger.
	^self familyName: familyName size: size emphasized: emphasisCode.
! !

!AbstractFont methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 23:34'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!AbstractFont methodsFor: '*sixx-printing' stamp: 'mu 12/12/2006 23:33'!
sixxContentString
	"Squeak Specific"
	^self fontNameWithPointSize, ' ', self emphasis asString! !

!TTCFont class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 23:38'!
familyName: aName size: aSize emphasized: emphasisCode
	^self familyName: aName pointSize: aSize emphasis: emphasisCode! !

!ByteArray class methodsFor: '*sixx-instance creation' stamp: 'mu 6/26/2004 18:36'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| rawStr col |
	rawStr := ReadStream
				on: (SixxXmlUtil characterDataFrom: sixxElement).
	col := rawStr peek = $#
				ifTrue: [Array readFrom: rawStr]
				ifFalse: [self readShortHexFrom: rawStr].
	^ self withAll: col! !

!ByteArray class methodsFor: '*sixx-instance creation' stamp: 'minami 7/14/2004 01:00'!
readShortHexFrom: aStream
	| sz inst |
	sz := aStream size // 2.
	inst := self new: sz.
	1 to: sz do: [:idx | 
		inst at: idx put: (Integer readShortHexFrom: (aStream next: 2) readStream)
	].
	^ inst! !

!ByteArray methodsFor: '*sixx-converting' stamp: 'minami 7/14/2004 00:42'!
shortHexString
	| sz stream |
	sz := self size.
	stream := WriteStream on: (String new: sz * 2).
	1 to: sz do: [:idx | 
		| elem |
		elem := (self at: idx).
		elem < 16 ifTrue: [stream nextPut: $0].
		stream nextPutAll:  elem shortHexString].
	^ stream contents  ! !

!ByteArray methodsFor: '*sixx-printing' stamp: 'minami 7/14/2004 00:43'!
sixxContentOn: aStream indent: level context: dictionary 
	1 to: self size do: [:idx | 
		| elem |
		elem := (self at: idx).
		elem < 16 ifTrue: [aStream nextPut: $0].
		aStream nextPutAll: elem shortHexString].
	! !

!Boolean class methodsFor: '*sixx-instance creation' stamp: 'mu 11/8/2006 14:51'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| read |
	read := SixxXmlUtil characterDataFrom: sixxElement.
	^ read = 'true'! !

!Boolean methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 16:20'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !

!Character class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:17'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Character methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:37'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString
	! !

!IntegerArray class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:19'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^ col asIntegerArray! !

!IntegerArray methodsFor: '*sixx-printing' stamp: 'MU 6/29/2002 16:03'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !

!Color class methodsFor: '*sixx-instance creation' stamp: 'MU 5/24/2003 18:22'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Color methodsFor: '*sixx-printing' stamp: 'kuri-t 5/14/2002 14:19'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self storeString! !

!String class methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/15/2002 18:07'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ SixxXmlUtil characterDataFrom: sixxElement! !

!String methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 20:04'!
sixxContentOn: aStream indent: level context: dictionary
	SixxXmlUtil writeXmlText: self on: aStream! !

!String methodsFor: '*sixx-private' stamp: 'mu 2/7/2006 21:11'!
sixxType
	^#String! !

!TTCFontSet class methodsFor: '*sixx-instance creation' stamp: 'mu 12/12/2006 23:38'!
familyName: aName size: aSize emphasized: emphasisCode
	^self familyName: aName pointSize: aSize emphasis: emphasisCode! !

!Behavior methodsFor: '*sixx-private' stamp: 'MU 3/6/2003 12:57'!
classFromSixxElement: sixxElement context: dictionary 
	| isClassClass type className retClass |
	isClassClass := false.
	type := self typeFromSixxElement: sixxElement.
	type isNil
		ifTrue: [^ nil].
	className := (type includes: Character space)
				ifTrue: [isClassClass := true.
					type copyUpTo: Character space]
				ifFalse: [type].
	retClass := SixxPortableUtil
				classAt: className
				in: (self envFromSixxElement: sixxElement).
	isClassClass
		ifTrue: [retClass := retClass class].
	^ retClass isNil
		ifTrue: [SixxClassNotFound
				signal: className
				element: sixxElement
				context: dictionary]
		ifFalse: [retClass]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 03:25'!
createInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"
	^ aClass isVariable
		ifTrue: [self createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement]
		ifFalse: [self sixxNew: aClass withSixxElement: sixxElement]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 03:25'!
createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"
	| nonameElems size |
	nonameElems := (SixxXmlUtil elementsFrom: sixxElement)
				select: [:each | (self nameFromSixxElement: each) isNil].
	size := nonameElems isEmpty
				ifTrue: [0]
				ifFalse: [nonameElems size].
	^ self
		sixxNew: aClass
		size: size
		withSixxElement: sixxElement! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 23:15'!
envFromSixxElement: sixxElement 
	^SixxXmlUtil attributeSymbolAt: SixxConstants current envTagName from: sixxElement.! !

!Behavior methodsFor: '*sixx-private' stamp: 'MU 5/31/2002 15:21'!
fromSixxElement: sixxElement context: aDictionary 
	^ (self includesRefInstanceFromSixxElement: sixxElement context: aDictionary)
		ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]
		ifFalse: [self newInstanceFromSixxElement: sixxElement context: aDictionary]! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 23:14'!
idFromSixxElement: sixxElement 
	^SixxXmlUtil attributeSymbolAt: SixxConstants current idTagName from: sixxElement.! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 23:14'!
idrefFromSixxElement: sixxElement
	^SixxXmlUtil attributeSymbolAt: SixxConstants current idrefTagName from: sixxElement.
	! !

!Behavior methodsFor: '*sixx-private' stamp: 'kuri-t 6/3/2002 16:06'!
includesRefInstanceFromSixxElement: sixxElement context: aDictionary 
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^ idref isNil
		ifTrue: [false]
		ifFalse: [aDictionary includesKey: idref]! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 23:13'!
nameFromSixxElement: sixxElement 
	^SixxXmlUtil attributeSymbolAt: SixxConstants current nameTagName from: sixxElement.
	! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 2/9/2007 10:29'!
newInstanceFromSixxElement: sixxElement context: aDictionary 
	| class inst elemId |
	class := self classFromSixxElement: sixxElement context: aDictionary .
	class isNil
		ifTrue: [class := SixxClassNotFound
				signal: (self typeFromSixxElement: sixxElement)
				element: sixxElement
				context: aDictionary].
	class ifNil: [^nil].
	inst := class createInstanceOf: class withSixxElement: sixxElement.
	elemId := self idFromSixxElement: sixxElement.
	aDictionary	at: elemId put: inst.
	inst initializeFromSixxElement: sixxElement context: aDictionary.
	inst sixxInitialize.
	inst := inst sixxReadValue.
	aDictionary	at: elemId put: inst.
	^ inst! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/20/2002 14:05'!
readSixxFrom: xmlStringOrStream 
	^ self readSixxFrom: xmlStringOrStream context: IdentityDictionary new! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'kuri-t 5/20/2002 14:04'!
readSixxFrom: xmlStringOrStream context: aDictionary 
	| topElem |
	topElem := SixxXmlUtil parseXml: xmlStringOrStream.
	^ self readSixxFromSixxElement: topElem context: aDictionary! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'kuri-t 6/3/2002 16:29'!
readSixxFromSixxElement: sixxElement context: aDictionary 
	| rootClass typeAttr |
	typeAttr := self typeFromSixxElement: sixxElement.
	^typeAttr isNil
		ifTrue: [(self includesRefInstanceFromSixxElement: sixxElement context: aDictionary)
				ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]]
		ifFalse: [rootClass := self classFromSixxElement: sixxElement context: aDictionary.
			rootClass isNil
				ifFalse: [rootClass fromSixxElement: sixxElement context: aDictionary]]! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 2/9/2007 10:20'!
refInstanceFromSixxElement: sixxElement context: aDictionary 
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^aDictionary at: idref! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/26/2004 16:21'!
sixxNew: aClass size: size withSixxElement: sixxElement 
	^ [aClass new: size]
		on: Error
		do: [:ex | 
			| alterClass | 
			alterClass := SixxNewFailed signal: aClass name element: sixxElement.
			alterClass isNil
				ifTrue: [[aClass basicNew: size] on: Error do: [self sixxNew: aClass withSixxElement: sixxElement ]]
				ifFalse: [alterClass basicNew: size]]! !

!Behavior methodsFor: '*sixx-instance creation' stamp: 'mu 6/24/2004 22:20'!
sixxNew: aClass withSixxElement: sixxElement 
	^[aClass new]
		on: Error
		do: [:ex | 
			| alterClass | 
			alterClass := SixxNewFailed signal: aClass name element: sixxElement.
			alterClass isNil
				ifTrue: [aClass basicNew]
				ifFalse: [alterClass basicNew]]! !

!Behavior methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 23:14'!
typeFromSixxElement: sixxElement 
	^SixxXmlUtil attributeSymbolAt: SixxConstants current typeTagName from: sixxElement.
	! !

!ArrayedCollection methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 03:44'!
initializeFromSixxElement: sixxElement context: aDictionary 
	"override to use #initializeMixedFieldsFromSixxElement:context: if having some inst vars"
	| idx |
	idx := 1.
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | childInst | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [childInst := self class fromSixxElement: elem context: aDictionary.
					self at: idx put: childInst.
					idx := idx + 1]]! !

!DateAndTime class methodsFor: '*sixx-instance creation' stamp: 'mu 3/29/2007 22:34'!
createInstanceOf: aClass withSixxElement: sixxElement 

	"For old format"
	(SixxXmlUtil elementsFrom: sixxElement ) isEmpty ifFalse: [
		^super createInstanceOf: aClass withSixxElement: sixxElement
	].

	^ self readSixxContentStringFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!DateAndTime class methodsFor: '*sixx-private' stamp: 'mu 3/29/2007 22:34'!
readSixxContentStringFrom: aStream
	"Squeak specific"
	^ self readFrom: aStream! !

!DateAndTime methodsFor: '*sixx-printing' stamp: 'mu 7/20/2006 15:47'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!DateAndTime methodsFor: '*sixx-private' stamp: 'mu 7/20/2006 15:47'!
sixxContentString
	"Squeak Specific"
	^self printString! !

!Text methodsFor: '*sixx-initializing' stamp: 'MU 7/21/2002 23:35'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst ]]]! !

!Text methodsFor: '*sixx-printing' stamp: 'mu 11/10/2006 14:12'!
sixxContentOn: aStream indent: level context: dictionary
	self sixxChildrenContentsOn: aStream indent: level + 1 context: dictionary.
	aStream tab: level.! !

!Object methodsFor: '*sixx-private' stamp: 'mu 2/9/2007 10:11'!
basicSixxOn: aStream originator: originator name: nameString indent: level context: dictionary 
	aStream tab: level.
	(dictionary includesKey: originator)
		ifTrue: [aStream
				nextPutAll: (self
						sixxRefTagStartString: (dictionary at: originator) name: nameString)]
		ifFalse: [| idStr | 
			idStr := dictionary size printString.			
			dictionary at: originator put: idStr.
			aStream
				nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/26/2004 18:05'!
initializeFromSixxElement: sixxElement context: aDictionary 
	self class isBits
		ifTrue: [^ self initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary].
	self class isVariable
		ifTrue: [^ self initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary].
	self initializeInstVarsFromSixxElement: sixxElement context: aDictionary! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 03:54'!
initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary 
	| idx nonameElems |
	idx := 1.
	nonameElems := (SixxXmlUtil elementsFrom: sixxElement)
				select: [:each | (self class nameFromSixxElement: each) isNil].
	nonameElems isEmpty
		ifFalse: [nonameElems
				do: [:elem | | childInst | (SixxXmlUtil isTextFrom: elem)
						ifFalse: [childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxAt: idx put: childInst.
							idx := idx + 1]]]! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/26/2004 18:04'!
initializeInstVarsFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/26/2004 18:05'!
initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary 
	self initializeInstVarsFromSixxElement: sixxElement context: aDictionary.
	self initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary ! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/25/2004 01:12'!
sixxAt: index put: aValue 
	"override if you like"
	self at: index put: aValue ! !

!Object methodsFor: '*sixx-private' stamp: 'mu 6/26/2004 16:45'!
sixxChildrenContentsOn: aStream indent: level context: dictionary 
	self class isBits
		ifTrue: [aStream nextPutAll: '#( '.
			1 to: self size do: [:idx | 
				aStream nextPutAll: (self at: idx) asString; space
			].
			aStream nextPutAll: ')'.
			^ self].
		
	self class isVariable
		ifTrue: [^ self
				sixxMixedFieldsOn: aStream
				indent: level
				context: dictionary].
			
	self
		sixxInstVarsOn: aStream
		indent: level
		context: dictionary! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 11/29/2006 22:41'!
sixxContentOn: aStream indent: level context: dictionary
	"Override if you like"
	"Typically usable for a customized serialization of the receiver's elements"
	self sixxChildrenContentsOn: aStream indent: level + 1 context: dictionary.
	aStream tab: level.
! !

!Object methodsFor: '*sixx-private' stamp: 'MU 3/6/2003 15:45'!
sixxEnv
	^SixxPortableUtil environmentQualifierOf: self class! !

!Object methodsFor: '*sixx-private' stamp: 'MU 3/6/2003 15:45'!
sixxEnvAttribString
	^'sixx.env="' , self sixxEnv , '" '! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxIdAttribString: idString
	^'sixx.id="', idString asString, '" '! !

!Object methodsFor: '*sixx-private' stamp: 'mu 11/29/2006 22:44'!
sixxIgnorableInstVarNames
	"Override if you wish"
	"If you would like to omit some inst vars in serialization, List their names here."

	^#()! !

!Object methodsFor: '*sixx-private' stamp: 'mu 11/10/2006 14:11'!
sixxIndexFieldsOn: aStream indent: level context: dictionary 
	"override if you like"
	| size |
	size := self basicSize.
	size = 0
		ifTrue: [^ self].
	1
		to: size
		do: [:i | 
			| element | 
			element := self basicAt: i.
			element 
				sixxOn: aStream
				indent: level
				context: dictionary]! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 6/24/2004 21:40'!
sixxInitialize
	"override if you like"
	"The method is called after the loading of the receiver - just like #initializaAfterLoad in Envy"
	"It is useful to initializa attributes that cannot be stored in SIXX (Block, Context, etc)"! !

!Object methodsFor: '*sixx-initializing' stamp: 'mu 12/21/2006 21:03'!
sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	"can be used for changing shape"
	| index |
	index _ self class allInstVarNames indexOf: instVarName asString.
	index = 0 ifTrue: [^self].
	self
		instVarAt: index
		put: aValue! !

!Object methodsFor: '*sixx-private' stamp: 'mu 1/15/2007 18:04'!
sixxInstVarNamed: varName value: varValue on: aStream indent: level context: dictionary 
	"override if you wish"
	((self sixxIgnorableInstVarNames collect: [:each | each asString]) includes: varName) ifTrue: [^self].
	varValue 
		sixxOn: aStream
		name: varName
		indent: level
		context: dictionary! !

!Object methodsFor: '*sixx-private' stamp: 'mu 7/20/2006 12:27'!
sixxInstVarsOn: aStream indent: level context: dictionary 
	| instVars ind |
	aStream cr.
	instVars := self class allInstVarNames.
	ind := 0.
	instVars
		do: [:nm | 
			ind := ind + 1.
			self
				sixxInstVarNamed: nm
				value: (self instVarAt: ind)
				on: aStream
				indent: level
				context: dictionary]! !

!Object methodsFor: '*sixx-private' stamp: 'mu 6/26/2004 16:45'!
sixxMixedFieldsOn: aStream indent: level context: dictionary
	self sixxInstVarsOn: aStream indent: level context: dictionary.
	self sixxIndexFieldsOn: aStream indent: level context: dictionary.! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxNameAttribString: idString
	^'sixx.name="', idString asString, '" '! !

!Object methodsFor: '*sixx-printing' stamp: 'kuri-t 5/17/2002 14:27'!
sixxOn: aStream 
	self sixxOn: aStream indent: 0 context: IdentityDictionary new! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:35'!
sixxOn: aStream indent: level context: dictionary
	^self sixxOn: aStream name: nil indent: level context: dictionary! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 2/9/2007 10:03'!
sixxOn: aStream name: nameString indent: level context: dictionary 
	self sixxPrepareWrite.
	self sixxWriteValue
		basicSixxOn: aStream
		originator: self
		name: nameString
		indent: level
		context: dictionary! !

!Object methodsFor: '*sixx-private' stamp: 'mu 11/29/2006 22:44'!
sixxPrepareWrite
	"Override if you like"
	"It is used for preparing the receiver's states for serialization "! !

!Object methodsFor: '*sixx-private' stamp: 'mu 11/29/2006 22:42'!
sixxReadValue
	"Override if you wish"
	"It can be useful when memento would like to return real object"

	^self! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxRefTagStartString: idString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	idString isNil
		ifFalse: [wStr
				nextPutAll: idString].
	wStr nextPutAll: '" >'.
	^ wStr contents! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxRefTagStartString: idString name: nameString 
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	wStr nextPutAll: idString.
	wStr nextPutAll: '" '.
	nameString notNil
		ifTrue: [wStr nextPutAll: 'sixx.name="'.
			wStr nextPutAll: nameString.
			wStr nextPutAll: '" '].
	wStr nextPutAll: '>'.
	^ wStr contents! !

!Object methodsFor: '*sixx-printing' stamp: 'mu 5/10/2002 14:34'!
sixxString
	| wStr |
	wStr := (String new: 128) writeStream.
	self sixxOn: wStr.
	^wStr contents! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxTagEndString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '</sixx.object>'.
	^wStr contents
	! !

!Object methodsFor: '*sixx-private' stamp: 'mu 12/19/2006 18:40'!
sixxTagStartString: idString name: nameString 
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object '.
	idString isNil
		ifFalse: [wStr
				nextPutAll: (self sixxIdAttribString: idString)].
	nameString isNil
		ifFalse: [wStr
				nextPutAll: (self sixxNameAttribString: nameString)].
	wStr nextPutAll: self sixxTypeAttribString.
	SixxSettings useEnvironment ifTrue: [wStr nextPutAll: self sixxEnvAttribString.].
	wStr nextPutAll: '>'.
	^ wStr contents! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxType
	^self class name! !

!Object methodsFor: '*sixx-private' stamp: 'mu 5/10/2002 14:35'!
sixxTypeAttribString
	^'sixx.type="', self sixxType, '" '! !

!Object methodsFor: '*sixx-private' stamp: 'mu 11/29/2006 22:41'!
sixxWriteValue
	"Override if you wish"
	"It can be useful when you would like to store the receiver in a memento (minimal representation) form."

	^self! !

!Date class methodsFor: '*sixx-instance creation' stamp: 'mu 1/16/2007 11:26'!
createInstanceOf: aClass withSixxElement: sixxElement
	^self readSixxContentStringFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !

!Date class methodsFor: '*sixx-private' stamp: 'mu 1/16/2007 11:27'!
readSixxContentStringFrom: aStream
	"Squeak specific"
	^ self readFrom: aStream! !

!Date methodsFor: '*sixx-printing' stamp: 'MU 9/16/2002 22:29'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !

!Date methodsFor: '*sixx-private' stamp: 'MU 9/16/2002 22:28'!
sixxContentString
	"Squeak Specific"
	^self printString! !

!ShortPointArray class methodsFor: '*sixx-instance creation' stamp: 'mu 6/25/2004 21:28'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| rawCol points index pointStream |
	rawCol := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	rawCol := rawCol reject: [:e | e == #@].
	points := (Array new: rawCol size //2).
	index := 1.
	pointStream _  rawCol readStream.
	[pointStream atEnd] whileFalse: [
		points at: index put: (Point x: pointStream next asNumber y: pointStream next asNumber).
		index := index + 1.
	].
	
	^self withAll: points! !

!Integer class methodsFor: '*sixx-instance creation' stamp: 'mu 6/26/2004 10:25'!
readShortHexFrom: aStream 
	| digit value startPos |
	value := 0.
	startPos := aStream position.
	[aStream atEnd]
		whileFalse: 
			[digit := aStream next digitValue.
			(digit < 0 or: [digit >= 16])
				ifTrue: 
					[aStream skip: -1.
					aStream position = startPos ifTrue: [self error: 'At least one digit expected here'].
					^ value]
				ifFalse: [value := value * 16 + digit]].
	^ value! !

!Integer methodsFor: '*sixx-printing' stamp: 'mu 6/26/2004 12:11'!
shortHexString
	| current letters digits quo i |
	digits := '0123456789ABCDEF'.
	current := self.
	i := self digitLength * 8.
	letters := String new: i.
	[current < 16] whileFalse: 
		[quo := current quo: 16.
		letters at: i put: (digits at: (current - (quo * 16)) + 1).
		i := i - 1.
		current := quo].
	letters at: i put: (digits at: current + 1).
	^letters copyFrom: i to: letters size! !

!ContextPart class methodsFor: '*sixx-instance creation' stamp: 'MU 10/27/2002 17:35'!
createInstanceOf: aClass withSixxElement: sixxElement 
	SixxInvalidDeserialization signal: aClass name element: sixxElement. 
	^nil! !

!ContextPart methodsFor: '*sixx-printing' stamp: 'MU 10/27/2002 17:24'!
sixxContentOn: aStream indent: level context: dictionary
	SixxInvalidSerialization signal: self class name context: dictionary.
	aStream nextPutAll: self printString! !

!RunArray class methodsFor: '*sixx-instance creation' stamp: 'MU 7/21/2002 23:30'!
createInstanceOf: aClass withSixxElement: sixxElement
	"squeak specific"
	
	^aClass basicNew! !

!RunArray methodsFor: '*sixx-initializing' stamp: 'MU 7/21/2002 23:35'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]! !

!RunArray methodsFor: '*sixx-printing' stamp: 'MU 7/9/2002 01:25'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream cr.
	self runs
		sixxOn: aStream
		name: 'runs'
		indent: level + 1
		context: dictionary.
	self values
		sixxOn: aStream
		name: 'values'
		indent: level + 1
		context: dictionary.
	aStream tab: level! !
